Subject: Re: [PATCH] net: phy: mscc: enable MAC SerDes autonegotiation

From: Raag Jadav <[email-masked]>
Date: Sun, 6 Feb 2022 22:42:34 +0530

On Sat, Feb 05, 2022 at 03:57:49PM +0100, Andrew Lunn wrote:
> On Sat, Feb 05, 2022 at 12:14:52PM +0530, Raag Jadav wrote:
> > Enable MAC SerDes autonegotiation to distinguish between
> > 1000BASE-X, SGMII and QSGMII MAC.
> 
> How does autoneg help you here? It just tells you about duplex, pause
> etc. It does not indicate 1000BaseX, SGMII etc. The PHY should be
> using whatever mode it was passed in phydev->interface, which the MAC
> sets when it calls the connection function. If the PHY dynamically
> changes its host side mode as a result of what that line side is
> doing, it should also change phydev->interface. However, as far as i
> can see, the mscc does not do this.
>

Once the PHY auto-negotiates parameters such as speed and duplex mode
with its link partner over the copper link as per IEEE 802.3 Clause 27,
the link partner’s capabilities are then transferred by PHY to MAC
over 1000BASE-X or SGMII link using the auto-negotiation functionality
defined in IEEE 802.3z Clause 37.

So any dynamic change in link partner’s capabilities over the copper link
can break MAC to PHY communication if MAC SerDes autonegotiation is disabled
even on active MAC interface link.

Is this understanding correct?

> So i don't understand this commit message.
> 

Will send out a v2 with updated commit message on confirmation.

Cheers,
Raag
 
>    Andrew